Option Explicit

const WMP_USERIMAGE_JS = "sm02\userimage\userimage.js"
Dim fso
Dim gsWorkPath, sWmzName, gsTargetFolderPath, gsZipFilePath, gsWmzFileName, gsWmzFilePath
Dim gsWmzSm02FolderPath, gsWmzUserImageFolderPath, gsWmzUserImageJsFilePath, gsNewWmzName
Set fso = WScript.CreateObject("Scripting.FileSystemObject")
Call main()
'===================================================================================================
' CWbN
'===================================================================================================
Sub main()
	Dim args, sMsg
	Set args = WScript.Arguments
	'---------------------------------------------------------------------------
	' R}hC̃`FbN
	'---------------------------------------------------------------------------
	' R}hC̐`FbN
	If args.Count <> 1 Then
		Call usage()
		Exit Sub
	End If
	' R}hC̑`FbN(wmzt@C)
	Dim reg
	Set reg = CreateObject("VBScript.RegExp")
	reg.Pattern = "sm02_[\d_]+\.wmz"
	reg.IgnoreCase = True
	If reg.Test(args(0)) = False Then
		sMsg =	"t@C`܂͖̂słB" & vbCrLf & _
				"usm02_yyyymmdd.wmzvƂ̂̃t@Cw肵ĂB" & vbCrLf & _
				"yyyymmdd́A_E[hXLɍ킹ĕύXĂB"
		Call popup(sMsg, "Error")
		Exit Sub
	End If
	'---------------------------------------------------------------------------
	' pX
	'---------------------------------------------------------------------------
	sWmzName = fso.GetBaseName(args(0))
	gsWorkPath = fso.GetParentFolderName(Wscript.ScriptFullName)
	gsTargetFolderPath = fso.BuildPath(gsWorkPath, sWmzName)
	gsWmzFileName = sWmzName & ".wmz"
	gsWmzFilePath = fso.BuildPath(gsWorkPath, gsWmzFileName)
	gsWmzUserImageJsFilePath = fso.BuildPath(gsTargetFolderPath, WMP_USERIMAGE_JS)
	gsWmzUserImageFolderPath = fso.GetParentFolderName(gsWmzUserImageJsFilePath)
	gsWmzSm02FolderPath = fso.GetParentFolderName(gsWmzUserImageFolderPath)
	gsZipFilePath = fso.BuildPath(gsWorkPath, sWmzName & ".zip")
	' wmzt@C̑݊mF
	If fso.FileExists(gsWmzFilePath) = False Then
		Call popup(args(0) & "t@C܂łB", "Error")
		Exit Sub
	End If
	'---------------------------------------------------------------------------
	' 摜t@C邩ǂ̊mF
	'---------------------------------------------------------------------------
	If checkExistsImageFile() = False Then
		Exit Sub
	End If
	'---------------------------------------------------------------------------
	' o̓tH_̍쐬
	'---------------------------------------------------------------------------
	' ÂtH_t@C폜
	If fso.FolderExists(gsTargetFolderPath) Then
		Call deleteFolder(gsTargetFolderPath)
	End If
	Call fso.CreateFolder(gsTargetFolderPath)
	'---------------------------------------------------------------------------
	' wmzt@C̉
	'---------------------------------------------------------------------------
	Call expandWmz()
	'---------------------------------------------------------------------------
	' 摜̎荞
	'---------------------------------------------------------------------------
	If setUserImage() <> 0 Then
		Call deleteFolder(gsTargetFolderPath)
		Exit Sub
	End If
	'---------------------------------------------------------------------------
	' wmzt@C쐬
	'---------------------------------------------------------------------------
	Call createWmz()
	'---------------------------------------------------------------------------
	' o̓tH_̍폜
	'---------------------------------------------------------------------------
	Call deleteFolder(gsTargetFolderPath)
	'---------------------------------------------------------------------------
	' bZ[W
	'---------------------------------------------------------------------------
	sMsg =	"wmzt@Cɉ摜t@Cǉ܂B" & vbCrLf & _
			"" & vbCrLf & _
			"[o̓t@C]" & vbCrLf & _
		gsNewWmzName
	Call popup(sMsg, "Success")
End Sub
'===================================================================================================
' g
'===================================================================================================
Sub usage()
	Dim sOutputMsg
	sOutputMsg = _
		"[{XNvgɂ]" & vbCrLf & _
		"Windows Media Player XL sm02ɔwi摜ǉXNvgłB" & vbCrLf & _
		"{XNvgƓtH_sm02_yyyymmdd.wmzƒǉ摜t@C(bmp,jpg,png,gif)zûAȉ̂ꂩ̕@ŃXNvgsĂB" & vbCrLf & _
		"" & vbCrLf & _
		"[R}hvvgs]" & vbCrLf & _
		"cscript sm02AddImage.vbs sm02_yyyymmdd.wmz" & vbCrLf & _
		"" & vbCrLf & _
		"[hbOhbvs]" & vbCrLf & _
		"sm02_yyyymmdd.wmzAsm02AddImage.vbs̏ɃhbOhbv" & vbCrLf & _
		"" & vbCrLf & _
		"yyyymmdd́A_E[hXLɍ킹ĕύXĂB"
	Call popup(sOutputMsg, "Info")
End Sub
'===================================================================================================
' 摜t@C邩ǂ̊mF
'===================================================================================================
Function checkExistsImageFile()
	checkExistsImageFile = False
	Dim folder, file, sExt, sMsg
	Set folder = fso.GetFolder(gsWorkPath)
	For Each file In folder.Files
		sExt = fso.GetExtensionName(file.Path)
		sExt = LCase(sExt)
		If sExt = "bmp" or sExt = "jpg" or sExt = "jpeg" or sExt = "png" or sExt = "gif" Then
	    	checkExistsImageFile = True
			Exit Function
		End If
	Next
	sMsg = _
		"摜t@C܂łB" & vbCrLf & _
		"{XNvgƓtH_ɉ摜t@C(bmp,jpg,jpeg,png,gif)zuĂB"
	Call popup(sMsg, "Error")
End Function
'===================================================================================================
' wmzt@C̓WJ
'===================================================================================================
Sub expandWmz()
	'---------------------------------------------------------------------------
	' wmzt@Czipt@CƂăRs[
	'---------------------------------------------------------------------------
	Call fso.CopyFile(gsWmzFilePath, gsZipFilePath, True)
	'---------------------------------------------------------------------------
	' k[`̌Ăяo
	' k̃t@CyуpXƈkΏۂi[ꂽzn
	'---------------------------------------------------------------------------
	Call expandFolder(gsZipFilePath, gsTargetFolderPath)
	'---------------------------------------------------------------------------
	' zipt@C̍폜
	'---------------------------------------------------------------------------
	Call fso.DeleteFile(gsZipFilePath)
End Sub
'===================================================================================================
' 摜̎荞
'===================================================================================================
Function setUserImage()
	Dim aryImageFile(), aryImageFile2, sMsg
	setUserImage = 0
	'---------------------------------------------------------------------------
	' tH_̑݊mF
	'---------------------------------------------------------------------------
	If fso.FolderExists(gsWmzUserImageFolderPath) = False Then
		sMsg = _
			"摜ǉɖΉsm02̂悤łB" & vbCrLf & _
			"ŐVsm02_E[hčĒ킵ĂB"
		Call popup(sMsg, "Error")
		setUserImage = 1
		Exit Function
	End If
	'---------------------------------------------------------------------------
	' St@C폜(=tH_č쐬)
	' {XNvg2xȏsƈȑÕt@Cĉ...
	'---------------------------------------------------------------------------
	Call deleteFolder(gsWmzUserImageFolderPath)
	Call fso.CreateFolder(gsWmzUserImageFolderPath)
	'---------------------------------------------------------------------------
	' 摜t@CRs[&t@C̎擾
	'---------------------------------------------------------------------------
	Dim folder, file, sExt
	Set folder = fso.GetFolder(gsWorkPath)
	For Each file In folder.Files
		sExt = fso.GetExtensionName(file.Path)
		sExt = LCase(sExt)
		If sExt = "bmp" or sExt = "jpg" or sExt = "jpeg" or sExt = "png" or sExt = "gif" Then
	    	Call fso.CopyFile(file.Path, gsWmzUserImageFolderPath & "\\")
			Call pushArray(aryImageFile, file.Name)
		End If
	Next
	' z̃\[g
	aryImageFile2 = sortArray(aryImageFile)
	'---------------------------------------------------------------------------
	' JSt@C̍쐬
	'---------------------------------------------------------------------------
	Dim jsFile, i, sFileContents, sFileName
	Set jsFile = fso.CreateTextFile(gsWmzUserImageJsFilePath)
	sFileContents = "CA_USER_IMAGE = ["
	For i = 0 To UBound(aryImageFile2)
		sFileName = fso.GetBaseName(aryImageFile2(i))
		sFileContents = sFileContents & vbCrLf & vbTab & _
				"{label:""" & sFileName & """,img:""" & aryImageFile2(i) & """},"
	Next
	sFileContents = Left(sFileContents, Len(sFileContents)-1)
	sFileContents = sFileContents & vbCrLf & "];"
	Call jsFile.WriteLine(sFileContents)
	Call jsFile.Close()
End Function
'===================================================================================================
' wmzt@C쐬
'===================================================================================================
Sub createWmz()
	'---------------------------------------------------------------------------
	' k[`̌Ăяo
	' k̃t@CyуpXƈkΏۂi[ꂽzn
	'---------------------------------------------------------------------------
	Call compressFolder(gsWmzSm02FolderPath, gsZipFilePath)
	'---------------------------------------------------------------------------
	' zipt@Cwmzt@C
	'---------------------------------------------------------------------------
	' dȂOŁAWMZt@CpX쐬
	Dim sNewWmzFilePath, bExistsPath, iCnt
	iCnt = 0
	Do
		iCnt = iCnt + 1
		gsNewWmzName = sWmzName & "_" & iCnt & ".wmz"
		sNewWmzFilePath = fso.BuildPath(gsWorkPath, gsNewWmzName)
		bExistsPath = fso.FileExists(sNewWmzFilePath)
	Loop While bExistsPath
	' l[
	On Error Resume Next
	Do
		With fso.GetFile(gsZipFilePath)
			.Name = gsNewWmzName
		End With
		If Err.Number = 0 Then
			Exit Do
		Else
			Call Wscript.Sleep(100)
		End If
	Loop While True
	On Error Goto 0
	Call Err.Clear()
End Sub
'===================================================================================================
' tH_k
' yQlzȂSE̎GL
' http://shiganaisenotes.blogspot.jp/2012/08/windowszip.html
'===================================================================================================
Sub compressFolder(sTargetFolderPath, sZipPath)
	Dim aryFile(0)
	'---------------------------------------------------------------------------
	' kΏۂ̃t@CAtH_̐-Pzm
	' zɈkΏۂ̃pX΃pXŒ`Ă
	'---------------------------------------------------------------------------
	aryFile(0) = sTargetFolderPath
	'---------------------------------------------------------------------------
	' Âzipt@C폜
	'---------------------------------------------------------------------------
	If fso.FileExists(sZipPath) Then
		fso.DeleteFile sZipPath
	End If
	'---------------------------------------------------------------------------
	' zipt@C쐬
	'---------------------------------------------------------------------------
	With fso.CreateTextFile(sZipPath, True)
		.Write "PK" & Chr(5) & Chr(6) & String(18,0)
		.Close
	End With
	'---------------------------------------------------------------------------
	' VK쐬zipt@CֈkΏۂRs[
	'---------------------------------------------------------------------------
	Dim app, file, iFileCnt, zipFolder
	Set app = CreateObject("Shell.Application")
	iFileCnt = 0
	' ZIPt@C̃pXϐɑāAlȉꍇ̓pXjɕωȂ悤ɂ
	Set zipFolder = app.NameSpace(fso.GetAbsolutePathName(sZipPath))
	For Each file In aryFile
		If CStr(file) <> "" Then
			file = fso.GetAbsolutePathName(file)
			'ZiptH_ɈkΏۂ̃t@CRs[
			zipFolder.CopyHere(file)
			't@CJEgAbv
			iFileCnt = iFileCnt + 1
		End If
	Next
	' ׂĂ̈kt@C̃Rs[I܂ő҂
	Do Until zipFolder.Items().Count = iFileCnt
		Call WScript.Sleep(100)
	Loop
	Call WScript.Sleep(500)
End Sub
'===================================================================================================
' tH_
' yQlzWSH
' http://home.a00.itscom.net/hatada/wsh/wsh01.html
'===================================================================================================
Sub expandFolder(sZipPath, sOutputFolderPath)
	Dim app, folder, zipContents
	Set app = CreateObject("Shell.Application")
	Set folder = app.NameSpace(sOutputFolderPath)
	Set zipContents = app.NameSpace(sZipPath)
	folder.CopyHere(zipContents.items())
End Sub
'===================================================================================================
' bZ[W\(WScript.EchowscriptoRōőOʂɏoȂƂ邽߁AvbSystemModall)
' yQlzMsgBox ֐bVBScript֐t@X
' http://www.kanaya440.com/contents/script/vbs/function/others/msgbox.html
' yQlzWSH - gŝwscriptcscript: ݃YƂY
' http://okazu.air-nifty.com/blog/2009/11/wsh---wscriptcs.html
'===================================================================================================
Sub popup(sMsg, sType)
	Dim iIcon, sTitle
	' bZ[W
	If sType = "Error" Then
		iIcon =  16	' [~] ACR
		sTitle = "G["
	ElseIf sType = "Success" Then
		iIcon = 64	' [i] ACR
		sTitle = "I"
	ElseIf sType = "Info" Then
		iIcon = 64	' [i] ACR
		sTitle = ""
	End If
	' sɉbZ[W\
	If LCase(Right(WScript.FullName, 11)) = "wscript.exe" Then
		Call MsgBox(sMsg, iIcon + 4096, sTitle)	'4096=vbSystemModal
	Else
		Call WScript.Echo("[" & sTitle & "]" & vbCrLf & sMsg)
	End If
End Sub
'===================================================================================================
' z̊g
' yQlzVBScript - Iz F Server World
' http://www.server-world.info/query?os=Other&p=vbs&f=3
'===================================================================================================
Sub pushArray(ary, elm)
	Dim i,tmp
	i = 0
	If IsArray(ary) Then
		For Each tmp In ary
			i = 1
			Exit For
		Next
		If i = 1 Then
			Redim Preserve ary(UBound(ary)+1)
		Else
			Redim ary(0)
		End If
	Else
		ary = Array(0)
	End If

	If IsObject(elm) Then
		Set ary(UBound(ary)) = elm
	Else
		ary(UBound(ary)) = elm
	End If
End Sub
'===================================================================================================
' z̃\[g
' yQlzVBScriptADODB.Recordsetgă\[g(sort)
' http://d.hatena.ne.jp/replication/20100702/1277996534
'===================================================================================================
Function sortArray(ary)
	Dim i, rs, aryTmp, aryRtn()
	' ADODB.Recordset쐬f[^ǉ
	Set rs = CreateObject("ADODB.Recordset")
	Call rs.Fields.Append("Field1", 200, 4096)	' 2varchar\萔A3̓f[^
	Call rs.Open()
	For i = 0 To UBound(ary)
		Call rs.AddNew()
		rs.Fields("Field1").Value = ary(i)
	Next
	Call rs.Update()
	' \[g
	rs.Sort = "Field1 ASC"
	aryTmp = rs.GetRows()
	rs.Close()
	' \[gl1zɓ
	For i = 0 To UBound(aryTmp, 2)
		Call pushArray(aryRtn, aryTmp(0, i))
	Next
	sortArray = aryRtn
End Function
'===================================================================================================
' tH_폜 ̂s邱Ƃ邽߁Afso.DeleteFolderbsO
' yQlzWSHDeleteFileɂĈُ픭
' https://social.technet.microsoft.com/Forums/ja-JP/6b5d4c81-7197-4950-a7b4-ff86e1fce42a/wshdeletefile?forum=suggestja
'===================================================================================================
Sub deleteFolder(sFolderPath)
	On Error Resume Next
	Do
		If fso.FolderExists(sFolderPath) = False Then
			Exit Do
		End If
		Call fso.DeleteFolder(sFolderPath)
		If Err.Number = 0 Then
			Exit Do
		Else
			Call Wscript.Sleep(100)
		End If
	Loop While True
	On Error Goto 0
	Call Err.Clear()
End Sub
